package org.krasnow.cng.domain;

public class SphericalPoint {

	private double r;
	private double theta;
	private double phi;
	private boolean calculated = false;

	private double x;
	private double y;
	private double z;

	public SphericalPoint(){
	}

	public SphericalPoint(double r, double theta, double phi){
		this.r = r;
		this.theta = theta;
		this.phi = phi;
	}
	
	public double getPhi() {
		return phi;
	}
	public void setPhi(double phi) {
		this.phi = phi;
		calculated = false;
	}
	public double getR() {
		return r;
	}
	public void setR(double r) {
		this.r = r;
		calculated = false;
	}
	public double getTheta() {
		return theta;
	}
	public void setTheta(double theta) {
		this.theta = theta;
		calculated = false;
	}
	
	public double getX(){
		if (!calculated){
			calculateEuclidean();
		}
		return x;
	}

	public double getY(){
		if (!calculated){
			calculateEuclidean();
		}
		return y;
	}

	public double getZ(){
		if (!calculated){
			calculateEuclidean();
		}
		return z;
	}

	private void calculateEuclidean(){
		if (r == 0){
			x = y = z = 0;
		}
		else{
			if (theta == 0){
				z = r;
			}
			else{
				double rSinTheta = r*Math.sin(theta);
				x = rSinTheta*Math.cos(phi);
				y = rSinTheta*Math.sin(phi);
				z = r*Math.cos(theta);
			}
		}
	}
	
}
