package org.krasnow.cng.domain;

public class SwcTreeNode extends StandardTreeNode {

	public SwcTreeNode(){
		data = new SwcDataNode();
	}
	
	public void setData(Object o) throws Exception{
		if (!o.getClass().equals(SwcDataNode.class)){
			throw new Exception("'data' member of SwcTreeNode must be of type SwcDataNode");
		}
		data = o;
	}
	
	public SwcDataNode getSwcData() {
		return (SwcDataNode)data;
	}
	public SwcTreeNode getSwcParent(){
		return (SwcTreeNode)parent;
	}
	public int getNodeId() {
		return getSwcData().getNodeId();
	}
	public void setNodeId(int nodeId) {
		getSwcData().setNodeId(nodeId);
	}
	public int getParentId() {
		return getSwcData().getParentId();
	}
	public void setParentId(int parentId) {
		getSwcData().setParentId(parentId);
	}
	public int getType() {
		return getSwcData().getType();
	}
	public void setType(int type) {
		getSwcData().setType(type);
	}
	
	public String toString(){
		return ("SwcTreeNode [nodeId: "+getNodeId()+"; parentId: "+getParentId()+"; type: "+getType()+"]");
	}
	public double getX() {
		return getSwcData().getX();
	}
	public void setX(double x) {
		getSwcData().setX(x);
	}
	public double getY() {
		return getSwcData().getY();
	}
	public void setY(double y) {
		getSwcData().setY(y);
	}
	public double getZ() {
		return getSwcData().getZ();
	}
	public void setZ(double z) {
		getSwcData().setZ(z);
	}
	public SwcSecondaryData getSecondaryData() {
		return getSwcData().getSecondaryData();
	}
	public void setSecondaryData(SwcSecondaryData secondaryData) {
		getSwcData().setSecondaryData(secondaryData);
	}
	public double getDiameter() {
		return getSwcData().getDiameter();
	}
	public double getRadius() {
		return getSwcData().getRadius();
	}
	public double getRadiusSquared() {
		return getSwcData().getRadiusSquared();
	}
	public void setRadius(double radius) {
		getSwcData().setRadius(radius);
	}
	public SwcTreeNode getSwcChild(int i){
		if (children != null && children.size() > i){
			return (SwcTreeNode)children.get(i);
		}
		return null;
	}
	
	public boolean equals(Object o){
		if (o != null && o.getClass().equals(this.getClass())){
			SwcTreeNode node = (SwcTreeNode)o;
			return (node.getNodeId() == this.getNodeId());
		}
		return false;
	}

	public int compareTo(Object o){
		if (o != null && o.getClass().equals(this.getClass())){
			SwcTreeNode node = (SwcTreeNode)o;
			return getNodeId() - node.getNodeId();
		}
		return 1;
	}
	
}
